/*
 * Copyright (C) 2017 Guido Berhoerster <guido+pwm@berhoerster.name>
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef	IO_H
#define	IO_H

#include <libtecla.h>
#include <stdarg.h>

enum io_status {
	IO_OK,
	IO_EOF = -1,
	IO_ERROR = -2,
	IO_TRUNCATED = -3,
	IO_SIGNAL = -4,
	IO_PASSWORD_EMPTY = -5,
	IO_PASSWORD_MISMATCH = -6
};

void		io_trim_nl(char *);
int		io_gl_complete_nothing(WordCompletion *, void *, const char *,
    int);
enum io_status	io_get_char(const char *, int *);
enum io_status	io_get_line(GetLine *, const char *, int, const char *, int,
    size_t, char *);
enum io_status	io_get_password(const char *, const char *, size_t, char *);
enum io_status	io_dputs(int, const char *);
enum io_status	io_vdprintf(int, const char *, va_list);
enum io_status	io_dprintf(int, const char *, ...);
enum io_status	io_printf(const char *, ...);

#endif /* !IO_H */
