/*
 * Copyright (C) 2017 Guido Berhoerster <guido+pwm@berhoerster.name>
 *
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
 * CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#ifndef	TOK_H
#define	TOK_H

enum tok_err {
	TOK_ERR_OK,
	TOK_ERR_UNTERMINATED_QUOTE = -1,
	TOK_ERR_TRAILING_BACKSLASH = -2,
	TOK_ERR_INVALID_MACRO_NAME = -3
};

enum tok_type {
	TOK_ARG,
	TOK_MACRO
};

struct tok_any {
	enum tok_type	type;
};

struct tok_arg {
	enum tok_type	type;
	char		*value;
};

struct tok_macro {
	enum tok_type	type;
	char		*name;
};

union tok {
	struct tok_any	any;
	struct tok_arg	arg;
	struct tok_macro macro;
};

void		tok_free(union tok **);
enum tok_err	tok_tokenize(const char *, size_t *, union tok ***);

#endif /* !TOK_H */
